## sagemath 8.8

=== sage/Makefile ===
# Main Makefile for Sage.

# The default target ("all") builds Sage and the whole (HTML) documentation.
#
# Target "build" just builds Sage.
#
# See below for targets to build the documentation in other formats,
# to run various types of test suites, and to remove parts of the build etc.

default: all

all: base-toolchain
	$(MAKE) all-start

build: base-toolchain
	$(MAKE) all-build

start: base-toolchain
	$(MAKE) build-start

sageruntime: base-toolchain
	$(MAKE) all-sageruntime


# The --stop flag below is just a random flag to induce graceful
# breakage with non-GNU versions of make.
# See https://trac.sagemath.org/ticket/24617

# Defer unknown targets to build/make/Makefile
%::
	@if [ -x relocate-once.py ]; then ./relocate-once.py; fi
	$(MAKE) build/make/Makefile --stop
	+build/bin/sage-logger \
		"cd build/make && ./install '$@'" logs/install.log

# If configure was run before, rerun it with the old arguments.
# Otherwise, run configure with argument $PREREQ_OPTIONS.
build/make/Makefile: configure build/make/deps build/make/Makefile.in build/pkgs/*/*
	rm -f config.log
	mkdir -p logs/pkgs
	ln -s logs/pkgs/config.log config.log
	@if [ -x config.status ]; then \
		./config.status --recheck && ./config.status; \
	else \
		./configure $$PREREQ_OPTIONS; \
	fi || ( \
		if [ "x$$SAGE_PORT" = x ]; then \
			echo "If you would like to try to build Sage anyway (to help porting),"; \
			echo "export the variable 'SAGE_PORT' to something non-empty."; \
			exit 1; \
		else \
			echo "Since 'SAGE_PORT' is set, we will try to build anyway."; \
		fi; )

# This is used to monitor progress towards Python 3 and prevent
# regressions.
buildbot-python3: configure
	./configure --with-python=3
	$(MAKE)

# Preemptively download all standard upstream source tarballs.
download:
	export SAGE_ROOT=$$(pwd) && \
	export PATH=$$SAGE_ROOT/src/bin:$$PATH && \
	./src/bin/sage-download-upstream

dist: build/make/Makefile
	./sage --sdist

# ssl: build Sage, and also install pyOpenSSL. This is necessary for
# running the secure notebook. This make target requires internet
# access. Note that this requires that your system have OpenSSL
# libraries and headers installed. See README.txt for more
# information.
ssl: all
	./sage -i pyopenssl

misc-clean:
	@echo "Deleting miscellaneous artifacts generated by build system ..."
	rm -rf logs
	rm -rf dist
	rm -rf tmp
	rm -f aclocal.m4 config.log config.status confcache
	rm -rf autom4te.cache
	rm -f build/make/Makefile build/make/Makefile-auto

bdist-clean: clean
	$(MAKE) misc-clean

distclean: build-clean
	$(MAKE) misc-clean
	@echo "Deleting all remaining output from build system ..."
	rm -rf local
	rm -f src/bin/sage-env-config

# Delete all auto-generated files which are distributed as part of the
# source tarball
bootstrap-clean:
	rm -rf config configure build/make/Makefile-auto.in

# Remove absolutely everything which isn't part of the git repo
maintainer-clean: distclean bootstrap-clean
	rm -rf upstream

# Remove everything that is not necessary to run Sage and pass all its
# doctests.
micro_release: bdist-clean sagelib-clean
	@echo "Stripping binaries ..."
	LC_ALL=C find local/lib local/bin -type f -exec strip '{}' ';' 2>&1 | grep -v "File format not recognized" |  grep -v "File truncated" || true
	@echo "Removing sphinx artifacts..."
	rm -rf local/share/doc/sage/doctrees local/share/doc/sage/inventory
	@echo "Removing documentation. Inspection in IPython still works."
	rm -rf local/share/doc local/share/*/doc local/share/*/examples local/share/singular/html
	@echo "Removing unnecessary files & directories - make will not be functional afterwards anymore"
	@# We need src/doc/common, src/doc/en/introspect for introspection with "??"
	@# We keep src/sage for some doctests that it expect it to be there and
	@# also because it does not add any weight with rdfind below.
	@# We need src/sage/bin/ for the scripts that invoke Sage
	@# We need sage, the script to start Sage
	@# We need local/, the dependencies and the built Sage library itself.
	@# We keep VERSION.txt.
	@# We keep COPYING.txt so we ship a license with this distribution.
	find . -name . -o -prune ! -name src ! -name sage ! -name local ! -name VERSION.txt ! -name COPYING.txt ! -name build -exec rm -rf \{\} \;
	cd src && find . -name . -o -prune ! -name sage ! -name bin ! -name doc -exec rm -rf \{\} \;
	if command -v rdfind > /dev/null; then \
		echo "Hardlinking identical files."; \
		rdfind -makeresultsfile false -makehardlinks true .; \
	else \
		echo "rdfind not installed. Not hardlinking identical files."; \
	fi

# Leaves everything that is needed to make the next "make" fast but removes
# all the cheap build artifacts that can be quickly regenerated.
fast-rebuild-clean: misc-clean bdist-clean
	rm -rf upstream/
	rm -rf src/build/temp.*
	# Without site-packages/sage sage does not start but copying/compiling
	# them from src/build is very fast.
	rm -rf local/lib/python*/site-packages/sage
	# The .py files in src/build are restored from src/sage without their
	# mtimes changed.
	find src/build -name '*.py' -exec rm \{\} \;

TESTALL = ./sage -t --all
PTESTALL = ./sage -t -p --all
PTEST_PYTHON3 = cat src/ext/doctest/python3-known-passing.txt | xargs ./sage -t --long -p

# Flags for ./sage -t --all.
# By default, include all tests marked 'dochtml' -- see
# https://trac.sagemath.org/ticket/25345 and
# https://trac.sagemath.org/ticket/26110.
TESTALL_FLAGS = --optional=sage,dochtml,optional,external,build

test: all
	$(TESTALL) --logfile=logs/test.log

check: test

testall: all
	$(TESTALL) $(TESTALL_FLAGS) --logfile=logs/testall.log

testlong: all
	$(TESTALL) --long --logfile=logs/testlong.log

testalllong: all
	$(TESTALL) --long $(TESTALL_FLAGS) --logfile=logs/testalllong.log

ptest: all
	$(PTESTALL) --logfile=logs/ptest.log

ptestall: all
	$(PTESTALL) $(TESTALL_FLAGS) --logfile=logs/ptestall.log

ptestlong: all
	$(PTESTALL) --long --logfile=logs/ptestlong.log

ptestalllong: all
	$(PTESTALL) --long $(TESTALL_FLAGS) --logfile=logs/ptestalllong.log

testoptional: all
	$(TESTALL) --logfile=logs/testoptional.log

testoptionallong: all
	$(TESTALL) --long --logfile=logs/testoptionallong.log

ptestoptional: all
	$(PTESTALL) --logfile=logs/ptestoptional.log

ptestoptionallong: all
	$(PTESTALL) --long --logfile=logs/ptestoptionallong.log

ptest-python3: buildbot-python3
	$(PTEST_PYTHON3) --logfile=logs/ptest_python3.log

configure: configure.ac src/bin/sage-version.sh m4/*.m4 build/pkgs/*/spkg-configure.m4
	./bootstrap -d

install: all
	@echo "******************************************************************"
	@echo "The '$@' target is a no-op; 'make' already does 'make install'"
	@echo "You can change the install prefix from its default"
	@echo "(the subdirectory 'local') by using ./configure --prefix=PREFIX"
	@echo "You can also consider using the binary packaging scripts"
	@echo "from https://github.com/sagemath/binary-pkg"
	@echo "******************************************************************"

list:
	@$(MAKE) --silent build/make/Makefile >&2
	@$(MAKE) --silent -f build/make/Makefile SAGE_SPKG_INST=local $@

.PHONY: default build install micro_release \
	misc-clean bdist-clean distclean bootstrap-clean maintainer-clean \
	test check testoptional testall testlong testoptionallong testallong \
	ptest ptestoptional ptestall ptestlong ptestoptionallong ptestallong \
	buildbot-python3 ptest-python3 list

## sagemath 9.0

=== sage/Makefile ===
--- 
+++ 
@@ -53,9 +53,11 @@
 		fi; )
 
 # This is used to monitor progress towards Python 3 and prevent
-# regressions.
-buildbot-python3: configure
-	./configure --with-python=3
+# regressions. Should be removed after the full switch to python3.
+#
+# As of Sage 9.0: keep the build target for backward compatibility,
+# but it just runs "make".
+buildbot-python3:
 	$(MAKE)
 
 # Preemptively download all standard upstream source tarballs.
@@ -76,16 +78,18 @@
 	./sage -i pyopenssl
 
 misc-clean:
-	@echo "Deleting miscellaneous artifacts generated by build system ..."
+	@echo "Deleting build artifacts generated by autoconf, automake, make ..."
 	rm -rf logs
 	rm -rf dist
 	rm -rf tmp
-	rm -f aclocal.m4 config.log config.status confcache
+	rm -f aclocal.m4 config.log confcache
 	rm -rf autom4te.cache
 	rm -f build/make/Makefile build/make/Makefile-auto
 
 bdist-clean: clean
 	$(MAKE) misc-clean
+	@echo "Deleting build artifacts generated by configure ..."
+	rm -f config.status
 
 distclean: build-clean
 	$(MAKE) misc-clean
@@ -104,7 +108,7 @@
 
 # Remove everything that is not necessary to run Sage and pass all its
 # doctests.
-micro_release: bdist-clean sagelib-clean
+micro_release: sagelib-clean misc-clean
 	@echo "Stripping binaries ..."
 	LC_ALL=C find local/lib local/bin -type f -exec strip '{}' ';' 2>&1 | grep -v "File format not recognized" |  grep -v "File truncated" || true
 	@echo "Removing sphinx artifacts..."
@@ -120,7 +124,7 @@
 	@# We need local/, the dependencies and the built Sage library itself.
 	@# We keep VERSION.txt.
 	@# We keep COPYING.txt so we ship a license with this distribution.
-	find . -name . -o -prune ! -name src ! -name sage ! -name local ! -name VERSION.txt ! -name COPYING.txt ! -name build -exec rm -rf \{\} \;
+	find . -name . -o -prune ! -name config.status ! -name src ! -name sage ! -name local ! -name VERSION.txt ! -name COPYING.txt ! -name build -exec rm -rf \{\} \;
 	cd src && find . -name . -o -prune ! -name sage ! -name bin ! -name doc -exec rm -rf \{\} \;
 	if command -v rdfind > /dev/null; then \
 		echo "Hardlinking identical files."; \
@@ -131,7 +135,7 @@
 
 # Leaves everything that is needed to make the next "make" fast but removes
 # all the cheap build artifacts that can be quickly regenerated.
-fast-rebuild-clean: misc-clean bdist-clean
+fast-rebuild-clean: misc-clean
 	rm -rf upstream/
 	rm -rf src/build/temp.*
 	# Without site-packages/sage sage does not start but copying/compiling
@@ -143,7 +147,6 @@
 
 TESTALL = ./sage -t --all
 PTESTALL = ./sage -t -p --all
-PTEST_PYTHON3 = cat src/ext/doctest/python3-known-passing.txt | xargs ./sage -t --long -p
 
 # Flags for ./sage -t --all.
 # By default, include all tests marked 'dochtml' -- see
@@ -188,9 +191,6 @@
 
 ptestoptionallong: all
 	$(PTESTALL) --long --logfile=logs/ptestoptionallong.log
-
-ptest-python3: buildbot-python3
-	$(PTEST_PYTHON3) --logfile=logs/ptest_python3.log
 
 configure: configure.ac src/bin/sage-version.sh m4/*.m4 build/pkgs/*/spkg-configure.m4
 	./bootstrap -d
@@ -212,4 +212,4 @@
 	misc-clean bdist-clean distclean bootstrap-clean maintainer-clean \
 	test check testoptional testall testlong testoptionallong testallong \
 	ptest ptestoptional ptestall ptestlong ptestoptionallong ptestallong \
-	buildbot-python3 ptest-python3 list
+	buildbot-python3 list

=== debian/changelog ===
sagemath (9.0-1ubuntu4) focal; urgency=medium

  * Allow up to 350 test failures.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 08 Feb 2020 14:46:38 +0100

sagemath (9.0-1ubuntu3) focal; urgency=medium

  * Don't try to build on armhf.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 08 Feb 2020 07:23:00 +0100

sagemath (9.0-1ubuntu2) focal; urgency=medium

  * No-change upload for libm4rie soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 01 Feb 2020 06:12:23 +0100

sagemath (9.0-1ubuntu1) focal; urgency=medium

  [ Tobias Hansen ]
  * New patches:
    - u0-version-python-3.8.patch                #27754

  [ Matthias Klose ]
  * Allow up to 300 test failures instead of 65.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 29 Jan 2020 17:51:55 +0100

sagemath (9.0-1) unstable; urgency=medium

  [ Tobias Hansen ]
  * New upstream release.
  * New (Build-)Depends:
    - ipython3 (>= 7.11.1) (Closes: #949287)
  * Remove (Build-)Depends:
    - python3-prompt-toolkit (Closes: #944544)
  * New patches (from Arch Linux):
    - u0-version-ipython-7.patch (Closes: #949446)
  * Remove patches:
    - u0-32bit-overflow-trac-28795.patch         #28795
    - u0-version-threejs-111.patch               #28560
    - d1-packages-exclude-pip.patch
    - d1-python3-shebang.patch
    - df-python_security.patch
    - dt-version-sympy-1.3.patch
  * Modify d1-sage-env.patch:
    Source sage-env earlier to fix 'sage -v' (Closes: #948731)
  * Depend on cython3 instead of cython (Closes: #938426)
  * Allow 25 failed indep doctests.

  [ Julien Puydt ]
  * Update d1-sage-env.patch to find scripts (Closes: #948212)

 -- Tobias Hansen <thansen@debian.org>  Wed, 22 Jan 2020 22:37:42 +0100

sagemath (8.9-3) unstable; urgency=medium

  * New (Build-)Depends:
    - libjs-three (>= 111)
  * New patch (Closes: #944648)
    - u0-32bit-overflow-trac-28795.patch         #28795
    - u0-version-threejs-111.patch               #28560
    - d1-packages-exclude-pip

 -- Tobias Hansen <thansen@debian.org>  Sun, 01 Dec 2019 12:26:58 +0000

sagemath (8.9-2) unstable; urgency=medium

  * Follow best practices for blas in Debian:
    - Build-Depend on libblas-dev instead of libopenblas-dev|libatlas-base-dev
    - Recommend libopenblas-base|libblis2|libatlas3-base|libblas3|libblas.so.3
  * Update pplpy documentation path for pplpy 0.8.4-3.
  * Add python3 environment variables to d/rules export-build-env.
  * New (Build-)Depends:
    - brial (>= 1.2.5-2)
  * Override lintian error for sagemath-dbgsym: field-too-long 'Build-Ids'.

 -- Tobias Hansen <thansen@debian.org>  Sun, 10 Nov 2019 21:41:38 +0100

sagemath (8.9-1) unstable; urgency=medium

  * New upstream release.
  * New (Build-)Depends:
    - libgivaro-dev (>= 4.1.1-2)

 -- Tobias Hansen <thansen@debian.org>  Tue, 01 Oct 2019 11:29:02 +0200

sagemath (8.9~beta9-1) unstable; urgency=medium

  [ Martin von Gagern ]
  * New patches:
    - dt-version-ipywidgets-6-tests.patch

  [ Tobias Hansen ]
  * New upstream release.
  * Use Python 3. (Closes: #938426, #939402)
  * Drop the deprecated Sage Notebook (sagenb) which is not
    Python 3 compatible. It is replaced by the Jupyter notebook.
  * New (Build-)Depends:
    - libpynac-dev (>= 0.7.26-2) (linked against libpython3)
    - libgivaro-dev (>= 4.1.1)
    - fflas-ffpack (>= 2.4.3)
    - liblinbox-dev (>= 1.6.3)
  * New patches:
    - u2-version-rpy-3.patch
    - d1-python3-shebang.patch
    - dt-version-sympy-1.3.patch
  * Remove obsolete patches:
    - debian/patches/d0-arb.patch
    - dt-work-around-doc-common-conf.patch
  * Replace language specific documentation packages
    by a single package sagemath-doc containing all languages.
  * Simplify pruner script, decleare all standard packages
    as installed.
  * Fix 3 doctests in interfaces/maxima_abstract.py.

 -- Tobias Hansen <thansen@debian.org>  Wed, 11 Sep 2019 21:12:30 +0200

sagemath (8.8-1) unstable; urgency=medium

  * New upstream release. (Closes: #932367, #934171)
  * New (Build-)Depends:
    - libbrial-dev (>= 1.2.5)
    - libbrial-groebner-dev (>= 1.2.5)
    - libec-dev (>= 20190226)
    - maxima-sage (>= 5.42.2)
    - python-cypari2 (>= 2.1)
    - python-gmpy2
    - python-nose
    - python-ppl
    - python-ppl-doc
    - python-scipy (>= 1.2)
    - python-sphinx (>= 1.8.5)
    - sagemath-database-conway-polynomials (>= 0.5-7)
  * Remove patches (applied upstream):
    - u0-version-numpy-1.16-inline-fortran.patch #27061
    - u0-version-sphinx-1.8.patch                #26451
    - u0-version-sphinx-1.8-dependency.patch     #26949
    - u1-sphinx-1.8-doctest-transform.patch      #27528
    - u2-libgap-symbol-loading.patch             #26930
    - d1-disable-post-install-tests.patch
  * Patches with non-trivial modifications:
    - u0-version-sphinx-1.8.patch                #26451
    - d0-singular.patch
    - d0-paths.patch
    - d0-libgap-path.patch
    - d1-install-paths.patch
    - d1-sage-cli.patch
    - d1-sage-env.patch
    - dt-version-ipywidgets-6-revert-23177.patch
  * Allow up to 65 failed tests.

 -- Tobias Hansen <thansen@debian.org>  Sun, 01 Sep 2019 16:14:42 +0000

=== debian/control ===
## DO NOT EDIT debian/control directly, edit debian/control.in instead
Source: sagemath
Section: math
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Tobias Hansen <thansen@debian.org>,
           Julien Puydt <julien.puydt@laposte.net>,
           Jerome Benoit <calculus@rezozer.net>,
           Ximin Luo <infinity0@debian.org>
Standards-Version: 4.4.0
Homepage: http://www.sagemath.org/
Vcs-Git: https://salsa.debian.org/science-team/sagemath.git
Vcs-Browser: https://salsa.debian.org/science-team/sagemath
Rules-Requires-Root: no
Build-Depends:
 cysignals-tools (>= 1.8.1) <!nodoc>,
 cython3 (>= 0.29.1),
 ecl (>= 16.1.3),
 eclib-tools (>= 20180815),
 fflas-ffpack (>= 2.4.3),
 flintqs,
 gap-dev (>= 4r10p0-3),
 gap-online-help,
 gap-atlasrep,
 gap-primgrp,
 gap-smallgrp,
 gap-transgrp,
 gap-table-of-marks,
 gfan (>= 0.6.2),
 gmp-ecm,
 ipython3 (>= 7.11.1),
 iso-codes,
 jmol (>= 14.6.4),
 lcalc (>= 1.23+dfsg-10),
 less,
 libcdd-tools (>= 094j),
 libjs-mathjax,
 libjs-three (>= 111),
 maxima-sage (>= 5.42.2),
 maxima-sage-share (>= 5.42.2),
 nauty,
 palp (>= 2.1-2),
 pari-gp (>= 2.11.0),
 pari-galdata,
 pari-seadata,
 python3,
 python3-alabaster,
 python3-babel,
 python3-brial (>= 1.2.5-2),
 python3-cvxopt,
 python3-cycler,
 python3-cypari2 (>= 2.1),
 python3-cysignals-pari (>= 1.8.1),
 python3-decorator,
 python3-docutils,
 python3-fpylll (>= 0.4.1),
 python3-future,
 python3-gmpy2,
 python3-imagesize,
 python3-ipython-genutils,
 python3-itsdangerous,
 python3-matplotlib (>= 2.1),
 python3-mistune,
 python3-mpmath,
 python3-networkx (>= 2.2),
 python3-nose,
 python3-numpy (>= 1:1.14),
 python3-openid,
 python3-packaging,
 python3-path,
 python3-pexpect (>= 4.1),
 python3-pickleshare,
 python3-pil,
 python3-pip,
 python3-pkgconfig,
 python3-ppl,
 python-ppl-doc (>= 0.8.4-3),
 python3-psutil,
 python3-ptyprocess,
 python3-pygments,
 python3-rpy2,
 python3-scipy (>= 1.2),
 python3-setuptools,
 python3-setuptools-scm,
 python3-simplegeneric,
 python3-singledispatch,
 python3-snowballstemmer,
 python3-sphinx (>= 1.8.5),
 python3-stemmer,
 python3-sympy,
 python3-terminado,
 python3-tornado,
 python3-traitlets,
 python3-twisted,
 python3-tz,
 python3-vcversioner,
 python3-wcwidth,
 python3-werkzeug,
 python3-zmq,
 python3-zope.interface,
 r-base-core,
 rubiks,
 sagemath-database-conway-polynomials (>= 0.5-7),
 sagemath-database-elliptic-curves,
 sagemath-database-graphs,
 sagemath-database-mutually-combinatorial-designs,
 sagemath-database-polytopes,
 singular (>= 1:4.1.1-p2),
 singular (<< 1:4.1.1-p3+ds-1),
 sqlite3,
 sympow (>= 1.023-9),
 tachyon,
 xcas,
 maxima-sage-doc (>= 5.42.2),
 pari-doc (>= 2.11.0),
 python3-sagenb-export (>= 3.2),
 r-cran-lattice,
 singular-doc (>= 1:4.1.1-p2),
 singular-doc (<< 1:4.1.1-p3+ds-1),
 jupyter-client,
 jupyter-core,
 jupyter-nbextension-jupyter-js-widgets,
 python3-ipykernel,
 python3-ipywidgets (>= 6.0.0),
 python3-nbconvert,
 python3-nbformat,
 python3-notebook (>= 4.2.3-3),
 autoconf,
 ccache <pkg.sagemath.ccache>,
 cython3-dbg <pkg.sagemath.dbg>,
 debhelper (>= 10),
 dh-python (>= 2.20170125),
 dpkg-dev (>= 1.17.14),
 gdb,
 git,
 libc6-dbg <pkg.sagemath.dbg>,
 libblas-dev,
 libboost-dev (>= 1.55),
 libbraiding-dev,
 libbrial-dev (>= 1.2.5-2),
 libbrial-groebner-dev (>= 1.2.5-2),
 libcdd-dev (>= 094j),
 libcliquer-dev,
 libec-dev (>= 20190226),
 libecm-dev,
 libflint-arb-dev (>= 1:2.15),
 libflint-dev (>= 2.5.2-5),
 libfplll-dev (>= 5.2.1),
 libfreetype6-dev,
 libgc-dev,
 libgd-dev,
 libgf2x-dev (>= 1.2-4),
 libgiac-dev (>= 1.4.9.69),
 libgivaro-dev (>= 4.1.1-2),
 libglpk-dev,
 libgmp-dev (>= 2:5.1.2),
 libgpg-error-dev,
 libgsl-dev (>= 2.4+dfsg-5~),
 libhomfly-dev,
 libiml-dev,
 liblfunction-dev (>= 1.23+dfsg-10),
 liblinbox-dev (>= 1.6.3),
 liblrcalc-dev (>= 1.2-2),
 libm4ri-dev (>= 20130416),
 libm4rie-dev (>= 20130416),
 libmpc-dev (>=1.0),
 libmpfi-dev,
 libmpfr-dev,
 libntl-dev (>= 9.9.1-2),
 libpari-dev (>= 2.11.0),
 libplanarity-dev,
 libpng-dev,
 libppl-dev (>= 1:1.1),
 libpynac-dev (>= 0.7.26-2),
 libratpoints-dev,
 libreadline-dev,
 librw-dev,
 libsingular4-dev (>= 1:4.1.1-p2),
 libsingular4-dev (<< 1:4.1.1-p3+ds-1),
 libsqlite3-dev,
 libsymmetrica-dev,
 libzn-poly-dev,
 pkg-config,
 python3-dev,
 python3-dbg <pkg.sagemath.dbg>,
 python3-cysignals-pari-dbgsym <pkg.sagemath.dbg>,
 r-base-dev,
 rdfind,
 texlive-latex-base,
 zlib1g-dev,

Package: sagemath
Architecture: amd64 arm64 ppc64el
Multi-Arch: same
Description: Open Source Mathematical Software
 SageMath is a free open-source mathematics software system licensed under the
 GPL. It builds on top of many existing open-source packages: NumPy, SciPy,
 matplotlib, Sympy, Maxima, GAP, FLINT, R and many more. Access their combined
 power through a common, Python-based language or directly via interfaces or
 wrappers.
 .
 Mission: Creating a viable free open source alternative to Magma, Maple,
 Mathematica and Matlab.
 .
 This package contains the main SageMath installation.
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends},
 cysignals-tools (>= 1.8.1) <!nodoc>,
 cython3 (>= 0.29.1),
 ecl (>= 16.1.3),
 eclib-tools (>= 20180815),
 fflas-ffpack (>= 2.4.3),
 flintqs,
 gap-dev (>= 4r10p0-3),
 gap-online-help,
 gap-atlasrep,
 gap-primgrp,
 gap-smallgrp,
 gap-transgrp,
 gap-table-of-marks,
 gfan (>= 0.6.2),
 gmp-ecm,
 ipython3 (>= 7.11.1),
 iso-codes,
 jmol (>= 14.6.4),
 lcalc (>= 1.23+dfsg-10),
 less,
 libcdd-tools (>= 094j),
 libjs-mathjax,
 libjs-three (>= 111),
 maxima-sage (>= 5.42.2),
 maxima-sage-share (>= 5.42.2),
 nauty,
 palp (>= 2.1-2),
 pari-gp (>= 2.11.0),
 pari-galdata,
 pari-seadata,
 python3,
 python3-alabaster,
 python3-babel,
 python3-brial (>= 1.2.5-2),
 python3-cvxopt,
 python3-cycler,
 python3-cypari2 (>= 2.1),
 python3-cysignals-pari (>= 1.8.1),
 python3-decorator,
 python3-docutils,
 python3-fpylll (>= 0.4.1),
 python3-future,
 python3-gmpy2,
 python3-imagesize,
 python3-ipython-genutils,
 python3-itsdangerous,
 python3-matplotlib (>= 2.1),
 python3-mistune,
 python3-mpmath,
 python3-networkx (>= 2.2),
 python3-nose,
 python3-numpy (>= 1:1.14),
 python3-openid,
 python3-packaging,
 python3-path,
 python3-pexpect (>= 4.1),
 python3-pickleshare,
 python3-pil,
 python3-pip,
 python3-pkgconfig,
 python3-ppl,
 python-ppl-doc (>= 0.8.4-3),
 python3-psutil,
 python3-ptyprocess,
 python3-pygments,
 python3-rpy2,
 python3-scipy (>= 1.2),
 python3-setuptools,
 python3-setuptools-scm,
 python3-simplegeneric,
 python3-singledispatch,
 python3-snowballstemmer,
 python3-sphinx (>= 1.8.5),
 python3-stemmer,
 python3-sympy,
 python3-terminado,
 python3-tornado,
 python3-traitlets,
 python3-twisted,
 python3-tz,
 python3-vcversioner,
 python3-wcwidth,
 python3-werkzeug,
 python3-zmq,
 python3-zope.interface,
 r-base-core,
 rubiks,
 sagemath-database-conway-polynomials (>= 0.5-7),
 sagemath-database-elliptic-curves,
 sagemath-database-graphs,
 sagemath-database-mutually-combinatorial-designs,
 sagemath-database-polytopes,
 singular (>= 1:4.1.1-p2),
 singular (<< 1:4.1.1-p3+ds-1),
 sqlite3,
 sympow (>= 1.023-9),
 tachyon,
 xcas,
 sagemath-common (= ${source:Version})
Recommends:
 maxima-sage-doc (>= 5.42.2),
 pari-doc (>= 2.11.0),
 python3-sagenb-export (>= 3.2),
 r-cran-lattice,
 singular-doc (>= 1:4.1.1-p2),
 singular-doc (<< 1:4.1.1-p3+ds-1),
 sagemath-doc (= ${source:Version}),
 sagemath-jupyter (= ${source:Version}),
 sagetex,
 texlive-latex-base,
 libopenblas-base | libblis2 | libatlas3-base | libblas3 | libblas.so.3
Suggests:
 dot2tex,
 gap-design,
 gap-factint,
 gap-grape,
 gap-guava,
 gap-laguna,
 gap-sonata,
 gap-toric

Package: sagemath-common
Architecture: all
Multi-Arch: foreign
Description: Open Source Mathematical Software - architecture-independent files
 SageMath is a free open-source mathematics software system licensed under the
 GPL. It builds on top of many existing open-source packages: NumPy, SciPy,
 matplotlib, Sympy, Maxima, GAP, FLINT, R and many more. Access their combined
 power through a common, Python-based language or directly via interfaces or
 wrappers.
 .
 Mission: Creating a viable free open source alternative to Magma, Maple,
 Mathematica and Matlab.
 .
 This package contains the architecture-independent files of SageMath.
Depends: ${misc:Depends}, ${python3:Depends}

Package: sagemath-jupyter
Architecture: all
Multi-Arch: foreign
Description: Open Source Mathematical Software - Jupyter kernel
 SageMath is a free open-source mathematics software system licensed under the
 GPL. It builds on top of many existing open-source packages: NumPy, SciPy,
 matplotlib, Sympy, Maxima, GAP, FLINT, R and many more. Access their combined
 power through a common, Python-based language or directly via interfaces or
 wrappers.
 .
 Mission: Creating a viable free open source alternative to Magma, Maple,
 Mathematica and Matlab.
 .
 This package contains the Jupyter kernel of SageMath.
Depends: ${misc:Depends},
 jupyter-client,
 jupyter-core,
 jupyter-nbextension-jupyter-js-widgets,
 python3-ipykernel,
 python3-ipywidgets (>= 6.0.0),
 python3-nbconvert,
 python3-nbformat,
 python3-notebook (>= 4.2.3-3),
 sagemath (>= ${source:Version}), sagemath (<< ${source:Version}.1~)

Package: sagemath-doc
Architecture: all
Description: Open Source Mathematical Software - documentation
 SageMath is a free open-source mathematics software system licensed under the
 GPL. It builds on top of many existing open-source packages: NumPy, SciPy,
 matplotlib, Sympy, Maxima, GAP, FLINT, R and many more. Access their combined
 power through a common, Python-based language or directly via interfaces or
 wrappers.
 .
 Mission: Creating a viable free open source alternative to Magma, Maple,
 Mathematica and Matlab.
 .
 This package contains the documentation.
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Built-Using: ${sphinxdoc:Built-Using}
Breaks: sagemath-doc-ca (<< 8.9~beta9-1~), sagemath-doc-de (<< 8.9~beta9-1~),
 sagemath-doc-en (<< 8.9~beta9-1~), sagemath-doc-es (<< 8.9~beta9-1~),
 sagemath-doc-fr (<< 8.9~beta9-1~), sagemath-doc-hu (<< 8.9~beta9-1~),
 sagemath-doc-it (<< 8.9~beta9-1~), sagemath-doc-ja (<< 8.9~beta9-1~),
 sagemath-doc-pt (<< 8.9~beta9-1~), sagemath-doc-ru (<< 8.9~beta9-1~),
 sagemath-doc-tr (<< 8.9~beta9-1~)
Replaces: sagemath-doc-ca (<< 8.9~beta9-1~), sagemath-doc-de (<< 8.9~beta9-1~),
 sagemath-doc-en (<< 8.9~beta9-1~), sagemath-doc-es (<< 8.9~beta9-1~),
 sagemath-doc-fr (<< 8.9~beta9-1~), sagemath-doc-hu (<< 8.9~beta9-1~),
 sagemath-doc-it (<< 8.9~beta9-1~), sagemath-doc-ja (<< 8.9~beta9-1~),
 sagemath-doc-pt (<< 8.9~beta9-1~), sagemath-doc-ru (<< 8.9~beta9-1~),
 sagemath-doc-tr (<< 8.9~beta9-1~)

Package: sagemath-doc-en
Depends: sagemath-doc, ${misc:Depends}
Architecture: all
Priority: optional
Section: oldlibs
Description: transitional package
 This is a transitional package. It can safely be removed.

=== debian/rules ===
#!/usr/bin/make -f

#
# CONTENTS:
#
# 1. DEFINITIONS
# 2. GENERATE FILES
#    Targets to auto-generate files
# 3. PACKAGE BUILD
#    Mostly standard targets that are used during package build
# 4. TEST SUITE
# 5. MAINTAINER TARGETS
#    Convenience targets to be used by maintainers
#    Some are explained at https://wiki.debian.org/DebianScience/Sage
#

###############################################################################
# 1. DEFINITIONS
###############################################################################

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/architecture.mk

MAX_TEST_FAILURES_RERUN = $(shell expr 2 \* $(MAX_TEST_FAILURES))

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
NUMJOBS = 1
endif

# Some buildds are a bit slow, see https://buildd.debian.org/status/logs.php?pkg=gcc-7 for a fuller list
ifneq (,$(filter $(DEB_BUILD_ARCH),armel armhf mips mipsel mips64el))
export SAGE_TIMEOUT_LONG = 7200
else
export SAGE_TIMEOUT_LONG = 3600
endif

# Use ccache if pkg.sagemath.ccache build-profile is active.
# Your rebuilds will be *much quicker*.
ifneq (,$(filter pkg.sagemath.ccache,$(DEB_BUILD_PROFILES)))
export PATH := /usr/lib/ccache:$(PATH)
export CCACHE_DIR := $(CURDIR)/debian/ccache
export CCACHE_BASEDIR := $(CURDIR)/debian/build
$(shell mkdir -p "$(CCACHE_DIR)")
endif

ifeq (,$(filter pkg.sagemath.nolongcheck,$(DEB_BUILD_PROFILES)))
SAGE_TEST_FLAGS_ARCH = --optional=sage,python3,memlimit --long
SAGE_TEST_FLAGS_INDEP = --optional=sage,python3,memlimit,dochtml --long
else
SAGE_TEST_FLAGS_ARCH = --optional=sage,python3,memlimit
SAGE_TEST_FLAGS_INDEP = --optional=sage,python3,memlimit,dochtml
endif

export SAGE_LOCAL = $(CURDIR)/debian/build/usr
export PYTHONPATH = $(CURDIR)/debian/build/usr/lib/python3/dist-packages
export DOT_SAGE = $(CURDIR)/debian/test
export SAGE_SCRIPTS_DIR = $(CURDIR)/sage/src/bin
export SAGE_PYTHON3=yes
export SAGE_PYTHON_VERSION=3

ifneq (1,$(TRY_AVOID_REBUILD))
REBUILD_RULES = debian/rules
endif

%:
	dh $@ --with=python3,sphinxdoc

###############################################################################
# 2. GENERATE FILES
###############################################################################

binary build clean install: debian/control

debian/control: debian/control.in
	cat $^ > "$@"
	sed -i -e '/RUNTIME_DEPENDS/ {' -e 'r debian/control.runtime-depends' -e 'd' -e '}' "$@"
	sed -i -e '/RUNTIME_RECOMMENDS/ {' -e 'r debian/control.runtime-recommends' -e 'd' -e '}' "$@"
	sed -i -e '/JUPYTER_DEPENDS/ {' -e 'r debian/control.jupyter-depends' -e 'd' -e '}' "$@"

../sagemath_$(DEB_VERSION_UPSTREAM).orig.tar.xz: .git/modules/sage/HEAD
	cd sage && git archive --prefix=sagemath_$(DEB_VERSION_UPSTREAM)/sage/ \
	  --format=tar HEAD | xz -zf > ../../sagemath_$(DEB_VERSION_UPSTREAM).orig.tar.xz

../sagemath_$(DEB_VERSION).dsc: distclean-sage distclean ../sagemath_$(DEB_VERSION_UPSTREAM).orig.tar.xz debian/control
	dpkg-buildpackage -nc -d -uc -us -S

###############################################################################
# 3. PACKAGE BUILD
###############################################################################

prune: debian/control
	cd sage && python3 ../debian/pruner.py --sageroot="$(CURDIR)/sage"
	touch prune

run_build = \
	MAKE='make -j$(NUMJOBS)' PREREQ_OPTIONS="--prefix=$(SAGE_LOCAL)" LDFLAGS="-Wl,-rpath,/usr/lib/$(DEB_HOST_MULTIARCH)/gap" \
	  $(MAKE) --directory=sage

override_dh_auto_configure: prune

override_dh_auto_build-arch:
	$(run_build) build
	cd sage && src/bin/sage-starts

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	$(run_build) doc
	cd debian/build/usr/share/doc/sagemath/html && \
	for statdir in */*/_static; do ln -s /usr/share/javascript/mathjax "$$statdir"; done && \
	for statdir in */_static; do ln -s /usr/share/javascript/mathjax "$$statdir"; done
endif

override_dh_auto_install:
	rm -rf debian/build/usr/var/tmp/sage/build
# We built .pyo to make the docbuild/tests go faster, but as per Debian policy
# we don't distribute them.
	find debian/build '(' -name '*.pyc' -o -name '*.pyo' ')' -delete
	rm -f debian/build/usr/bin/*.bat
	mkdir -p debian/tmp
	mv debian/build/* debian/tmp
	cp -f debian/adhoc/sage-env debian/tmp/usr/bin/
# Install sage-python23 which is required at runtime but located in build/bin.
	cp -f sage/build/bin/sage-python23  debian/tmp/usr/bin/
# Don't install sage-env-config.
	rm -f debian/tmp/usr/bin/sage-env-config
# Install (renamed) icons.
	mkdir -p debian/tmp/usr/share/icons/hicolor/64x64/apps
	mkdir -p debian/tmp/usr/share/icons/hicolor/scalable/apps
	cp -f sage/src/ext/notebook-ipython/logo-64x64.png debian/tmp/usr/share/icons/hicolor/64x64/apps/sagemath.png
	cp -f sage/src/ext/notebook-ipython/logo.svg debian/tmp/usr/share/icons/hicolor/scalable/apps/sagemath.svg
# Don't try to rmdir debian/build if it's a mountpoint, useful for doing builds in /run/shm
	mountpoint debian/build || rmdir debian/build

# If we see "nodoc", don't clean the docs. This allows us to rebuild just the
# non-docs without wiping away the docs we previously built, to save time.
override_dh_auto_clean:
ifneq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	dh_auto_clean -Dsage -- -k clean sagelib-clean misc-clean bootstrap-clean || true
	rm -rf sage/local sage/upstream
else
	dh_auto_clean -Dsage -- maintainer-clean
	rm -f sage/config.status
endif

override_dh_install-indep:
	dh_install --package sagemath-common -X.so
	dh_install --remaining-packages --list-missing
# Basic version of deduplicating the docs, for a much smaller install size.
# Upstream bug report is at https://trac.sagemath.org/ticket/22088
# Hard links do work in Debian packages, but only within packages.
	rdfind -outputname /dev/null -makehardlinks true debian/sagemath-doc; \

override_dh_python3-arch:
	dh_python3
	dh_numpy3 --package sagemath # stop lintian complaining at us

override_dh_shlibdeps:
	dh_shlibdeps -l debian/tmp/usr/lib

override_dh_compress:
# We probably don't need to install the pickle/doctree files but let's exempt
# them from compression anyway for now, so the build goes quicker.
	dh_compress -X.pdf -X.pickle -X.doctree

override_dh_sphinxdoc:
# TODO: fix MathJax.js, Sage needs special treatment
# `man dh_sphinxdoc` says symlinking translations.js is not yet supported
# likewise, it seems not to recognise searchtools.js yet
	dh_sphinxdoc -XMathJax.js -Xtranslations.js -Xsearchtools.js

# If we see "nodoc", don't clean the docs. This allows us to rebuild just the
# non-docs without wiping away the docs we previously built, to save time.
ifneq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
# Don't delete my precious docs debhelper! They took a whole fucking hour to build!
preserve_docs = \
	set -e; \
	if [ -d $(2)/usr/share/doc ]; then \
		mkdir -p debian/clean-tmp/usr/share; \
		mv -t debian/clean-tmp/usr/share/ $(2)/usr/share/doc; \
	fi; \
	$(1); \
	if [ -d debian/clean-tmp/usr/share/doc ]; then \
		mkdir -p $(2)/usr/share; \
		mv -t $(2)/usr/share/ debian/clean-tmp/usr/share/doc; \
		rm -rf debian/clean-tmp; \
	fi
else
preserve_docs = $(1)
endif
override_dh_clean:
	rm -rf $(DOT_SAGE)
	$(call preserve_docs,dh_clean,debian/tmp)
	$(call preserve_docs,rm -rf debian/build/*,debian/build)

override_dh_strip_nondeterminism:
	dh_strip_nondeterminism -X.png # On png files it sometimes fails claiming it's not a png file.

###############################################################################
# 4. TEST SUITE
###############################################################################

TESTS_MK = $(MAKE) -s --no-print-directory -f debian/tests.mk LOGFILE=$(LOGFILE)
failed-tests%:
	@$(TESTS_MK) "$@"

# We used to set this for i386 but it seems to be OK now.
# Perhaps we should set it for armhf, let's see the buildd test results...
ifneq (,$(filter $(DEB_BUILD_ARCH),))

=== debian/watch ===
version=4
http://files.sagemath.org/src/index.html ./sage-([\d\.]+)\.tar\.gz

## sagemath 9.2~beta12

=== debian/changelog ===
sagemath (9.2~beta12-1) unstable; urgency=medium

  * New upstream release. (Closes: #949023, #963338)
  * We are now using upstream's new configure script that checks for
    system packages and configures sage to use them. It does not
    recognize all system packages yet, so we patched it to never
    build any spkg's (d1-no-spkg-builds.patch).
    At the same time we changed some details about how sage is installed
    and tried to remove as many patches as possible.
  * Add debian/depcheck.py and run it after configure.
    This script checks for all (Build-)Depends of the Debian package
    if they appear in the debian.txt files under sage/build/pkgs/*/distros
    and reports which ones do not appear in debian.txt files.
    This can be used to find obsolete package Depends and to help create
    missing debian.txt files.
  * New (Build-)Depends:
    - curl
    - ecl (>= 20.4.24)
    - glpk-utils
    - libcurl4-openssl-dev
    - libopenblas-dev
    - libzmq3-dev
    - maxima-sage (>= 5.44.0)
    - pari-gp2c
    - pari-elldata
    - pari-galpol
    - ppl-dev
    - pynac (>= 0.7.26-5)
    - python3-sphinx (>= 3.0)
    - python3-tk
    - yasm
  * Remove (Build-)Depends:
    - libblas-dev
    - python3-brial (>= 1.2.5-2)
  * New patches:
    - u0-version-flint-2.6.3.patch               #29719
    - d0-arb.patch
    - d1-sage.patch
    - d1-no-spkg-builds.patch
    - d1-system-python-packages.patch
    - dt-avoid-ecl-timeout.patch
    - dt-avoid-giac-segfault.patch
  * Remove patches (in refactoring for 9.2):
    - u1-fix-atrocious-symlink-logic.patch       #22444
    - u1-looser-doctest-basename.patch           #22445
    - u1-workaround-sympow-malloc-perturb.patch
    - u2-allow-override-sage-local.patch
    - d0-arb.patch
    - d0-disable-jsmol.patch
    - d1-sage-cli.patch
    - df-sage-gap-reset-doctest.patch
    - df-silence_ecl_opt_signals.patch
    - d0-threejs-default-in-notebooks.patch
    - d0-paths.patch
    - d0-threejs-offline-paths.patch
    - d1-install-paths.patch
    - d1-multiarch-python-paths.patch
    - dt-version-glpk-4.60-extra-hacky-fixes.patch
    - dt-more-fix-test-cases.patch
    - dt-work-around-singular-mips64el-segfault.patch
  * Remove patches (applied upstream in 9.2):
    - u0-version-sphinx-2.4.patch                #28856
    - u0-version-pari-2.11.3.patch               #29313
    - u0-version-ecl-16.1.3.patch                #22191
    - u0-version-ipython-7.patch                 #28197
    - u2-version-matplotlib-3.2.1.patch
    - u0-version-python-3.8.patch                #27754
  * Remove patches (applied upstream in 9.1):
    - u0-version-scipy-1.4.patch                 #29115
    - u0-version-sympy-1.5.patch                 #28911
    - u1-pkgconfig-extra-link-flags.patch        #27205
    - u1-fix-trivial-test-cases.patch
    - u2-version-rpy-3.patch
    - d0-nauty.patch
    - d1-fakeroot.patch
    - dt-version-glpk-4.65-ignore-warnings.patch
  * Pass --enable-build-as-root to ./configure.

 -- Tobias Hansen <thansen@debian.org>  Sat, 12 Sep 2020 09:52:45 +0000

sagemath (9.0-4) unstable; urgency=medium

  * New (Build-)Depends:
    - gap-dev (>= 4.11.0)
    - libgap-dev
  * New patches:
    - u0-version-gap-4.11.patch                  #29314
    - u0-version-sphinx-2.4.patch                #28856
    - u0-version-scipy-1.4.patch                 #29115
  * Remove patches:
    - d0-libgap-path.patch
    - df-revert-minor-feature-dependent-on-python-patch.patch
    - df-subprocess-sphinx.patch
  * Modified patches:
    - u0-version-python-3.8.patch (add 32-bit hashes)
  * Allow up to 200 failed doctests.
  * Stop using dh_sphinxdoc.

 -- Tobias Hansen <thansen@debian.org>  Sat, 25 Apr 2020 15:09:00 +0000

sagemath (9.0-3) unstable; urgency=medium

  [ Julien Puydt ]
  * Mark the -doc-en package M-A: foreign following hinter.

  [ Tobias Hansen ]
  * New (Build-)Depends:
    - pari (>= 2.11.4~pre1)
    - gap-atlasrep (>= 2.1.0-2)
    - libec-dev (>= 20190909-3)
  * Remove (Build-)Depends:
    - python3-openid   #29320
    - python3-twisted  #29320
  * New patches:
    - u0-version-python-3.8.patch (Closes: #950147)
    - u0-version-pari-2.11.3.patch               #29313
    - u0-version-sympy-1.5.patch                 #28911
    - u2-version-matplotlib-3.2.1.patch (Closes: #954504)

 -- Tobias Hansen <thansen@debian.org>  Sat, 04 Apr 2020 20:48:51 +0200

sagemath (9.0-2) unstable; urgency=medium

  * Update PPLPY_DOCS variable following move of pplpy documentation.
    (Closes: #952618)

 -- Tobias Hansen <thansen@debian.org>  Wed, 26 Feb 2020 16:32:50 +0000

=== debian/rules ===
#!/usr/bin/make -f

#
# CONTENTS:
#
# 1. DEFINITIONS
# 2. GENERATE FILES
#    Targets to auto-generate files
# 3. PACKAGE BUILD
#    Mostly standard targets that are used during package build
# 4. TEST SUITE
# 5. MAINTAINER TARGETS
#    Convenience targets to be used by maintainers
#    Some are explained at https://wiki.debian.org/DebianScience/Sage
#

###############################################################################
# 1. DEFINITIONS
###############################################################################

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/architecture.mk

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
NUMJOBS = 1
endif

# Some buildds are a bit slow, see https://buildd.debian.org/status/logs.php?pkg=gcc-7 for a fuller list
ifneq (,$(filter $(DEB_BUILD_ARCH),armel armhf mips mipsel mips64el))
export SAGE_TIMEOUT_LONG = 7200
else
export SAGE_TIMEOUT_LONG = 3600
endif

export DOT_SAGE = $(CURDIR)/debian/test

%:
	dh $@ --with=python3

###############################################################################
# 2. GENERATE FILES
###############################################################################

binary build clean install: debian/control

debian/control: debian/control.in
	cat $^ > "$@"
	sed -i -e '/RUNTIME_DEPENDS/ {' -e 'r debian/control.runtime-depends' -e 'd' -e '}' "$@"
	sed -i -e '/RUNTIME_RECOMMENDS/ {' -e 'r debian/control.runtime-recommends' -e 'd' -e '}' "$@"
	sed -i -e '/JUPYTER_DEPENDS/ {' -e 'r debian/control.jupyter-depends' -e 'd' -e '}' "$@"

###############################################################################
# 3. PACKAGE BUILD
###############################################################################

run_build = \
	MAKE='make -j$(NUMJOBS)' \
	  $(MAKE) --directory=sage

override_dh_auto_configure:
	cd sage && ./bootstrap
	cd sage && ./configure --enable-build-as-root
	debian/depcheck.py

clean:

override_dh_auto_build-arch:
	$(run_build) build

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	$(run_build) doc
	cd sage/local/share/doc/sagemath/html && \
	for statdir in */*/_static; do ln -s /usr/share/javascript/mathjax "$$statdir"; done && \
	for statdir in */_static; do ln -s /usr/share/javascript/mathjax "$$statdir"; done
endif

override_dh_auto_install:
	mkdir -p debian/tmp
	mv sage/local debian/tmp/usr
	mv debian/tmp/usr/lib/python3.8 debian/tmp/usr/lib/python3
	mv debian/tmp/usr/lib/python3/site-packages debian/tmp/usr/lib/python3/dist-packages
	mkdir -p debian/tmp/usr/share/sagemath/bin
	cp sage/src/bin/sage-* debian/tmp/usr/share/sagemath/bin
	rm -f debian/tmp/usr/bin/sage-*
	rm -f debian/tmp/usr/share/sagemath/bin/sage-env*
	rm -f debian/tmp/usr/share/sagemath/bin/sage-*.bat
# We built .pyo to make the docbuild/tests go faster, but as per Debian policy
# we don't distribute them.
	find debian/tmp '(' -name '*.pyc' -o -name '*.pyo' ')' -delete
# Install (renamed) icons.
	mkdir -p debian/tmp/usr/share/icons/hicolor/64x64/apps
	mkdir -p debian/tmp/usr/share/icons/hicolor/scalable/apps
	cp -f sage/src/sage/ext_data/notebook-ipython/logo-64x64.png debian/tmp/usr/share/icons/hicolor/64x64/apps/sagemath.png
	cp -f sage/src/sage/ext_data/notebook-ipython/logo.svg debian/tmp/usr/share/icons/hicolor/scalable/apps/sagemath.svg
# Fix up jupyter kernel installation
	rm -f debian/tmp/usr/share/jupyter/nbextensions/jsmol
	rm -f debian/tmp/usr/share/jupyter/kernels/sagemath/logo*
	rm -f debian/tmp/usr/share/jupyter/kernels/sagemath/doc
	ln -s /usr/share/doc/sagemath/html/en debian/tmp/usr/share/jupyter/kernels/sagemath/doc
	ln -s /usr/share/icons/hicolor/64x64/apps/sagemath.png debian/tmp/usr/share/jupyter/kernels/sagemath/logo-64x64.png
	ln -s /usr/share/icons/hicolor/scalable/apps/sagemath.svg debian/tmp/usr/share/jupyter/kernels/sagemath/logo.svg
	sed -E 's|\[\".+bin/sage\",|\[\"/usr/bin/sage\",|' -i debian/tmp/usr/share/jupyter/kernels/sagemath/kernel.json

#override_dh_auto_clean:
#	dh_auto_clean -Dsage -- maintainer-clean
#	rm -f sage/config.status

override_dh_install-indep:
	dh_install --package sagemath-common -X.so
	dh_install --remaining-packages --list-missing
# Basic version of deduplicating the docs, for a much smaller install size.
# Upstream bug report is at https://trac.sagemath.org/ticket/22088
# Hard links do work in Debian packages, but only within packages.
	rdfind -outputname /dev/null -makehardlinks true debian/sagemath-doc; \

override_dh_python3-arch:
	dh_python3
	dh_numpy3 --package sagemath # stop lintian complaining at us

override_dh_shlibdeps:
	dh_shlibdeps -l debian/tmp/usr/lib

override_dh_compress:
# We probably don't need to install the pickle/doctree files but let's exempt
# them from compression anyway for now, so the build goes quicker.
	dh_compress -X.pdf -X.pickle -X.doctree

override_dh_clean:
	rm -rf $(DOT_SAGE)
	dh_clean

override_dh_strip_nondeterminism:
	dh_strip_nondeterminism -X.png # On png files it sometimes fails claiming it's not a png file.

###############################################################################
# 4. TEST SUITE
###############################################################################

MAX_TEST_FAILURES_RERUN = $(shell expr 2 \* $(MAX_TEST_FAILURES))

ifeq (,$(filter pkg.sagemath.nolongcheck,$(DEB_BUILD_PROFILES)))
SAGE_TEST_FLAGS_ARCH = --optional=sage,python3,memlimit --long
SAGE_TEST_FLAGS_INDEP = --optional=sage,python3,memlimit,dochtml --long
else
SAGE_TEST_FLAGS_ARCH = --optional=sage,python3,memlimit
SAGE_TEST_FLAGS_INDEP = --optional=sage,python3,memlimit,dochtml
endif

TESTS_MK = $(MAKE) -s --no-print-directory -f debian/tests.mk LOGFILE=$(LOGFILE)
failed-tests%:
	@$(TESTS_MK) "$@"

# We used to set this for i386 but it seems to be OK now.
# Perhaps we should set it for armhf, let's see the buildd test results...
ifneq (,$(filter $(DEB_BUILD_ARCH),))
IGNORE_FAILURES = | sed -e '0,/Timed out/{//d;}' -e '0,/Timed out/{//d;}' -e '0,/Timed out/{//d;}'
else
IGNORE_FAILURES =
endif
had-few-failures:
	if ! test -f $(LOGFILE); then echo "Error: log file $(LOGFILE) not found"; false; fi
	N_TEST_FAILURES="$$($(TESTS_MK) failed-tests-total-normal)"; \
	  if ! test $${N_TEST_FAILURES} -le $(MAX_TEST_FAILURES); then \
	    echo "Error: $${N_TEST_FAILURES} tests failed, up to $(MAX_TEST_FAILURES) failures are tolerated"; \
	    false; \
	  else \
	    echo "Success: $${N_TEST_FAILURES} tests failed, up to $(MAX_TEST_FAILURES) failures are tolerated"; \
	  fi
	if ! test -z "$$($(TESTS_MK) failed-tests-special $(IGNORE_FAILURES))"; then \
	  echo "Error: critical test failures (e.g. timeout, segfault, etc.)"; false; fi

had-not-too-many-failures:
	echo "Checking number of failed tests to determine whether to rerun tests in series..."
	if ! test -f $(LOGFILE); then echo "Error: log file $(LOGFILE) not found"; false; fi
	N_TEST_FAILURES="$$($(TESTS_MK) failed-tests-total-normal)"; \
	  if ! test $${N_TEST_FAILURES} -le $(MAX_TEST_FAILURES_RERUN); then \
	    echo "No: $${N_TEST_FAILURES} tests failed, up to $(MAX_TEST_FAILURES_RERUN) failures are tolerated for rerun"; \
	    false; \
	  else \
	    echo "Yes: $${N_TEST_FAILURES} tests failed, up to $(MAX_TEST_FAILURES_RERUN) failures are tolerated for rerun"; \
	  fi

run_tests = \
	cd sage && ./sage -t -p $(NUMJOBS) --logfile=logs/ptestlong-$(1).log $(2)
# If tests fail but not by too many more, then retry them once not in parallel
# i386 seems to have issues running parallel tests - TODO: investigate this in more detail
check_test_log = debian/rules -s LOGFILE=sage/logs/ptestlong-$(1).log MAX_TEST_FAILURES=$(3)
run_tests_with_retry = \
	$(run_tests); cd "$(CURDIR)" && \
	if $(check_test_log) had-few-failures; then :; else \
	  $(check_test_log) had-not-too-many-failures && \
	  mv sage/logs/ptestlong-$(1).log sage/logs/ptestlong-$(1).log.1 && \
	  { $(run_tests) -p 1 -f; cd "$(CURDIR)" && \
